'FFSubmenu=Tools
'FFName=DateToExif

'Skriptname: DateToExif.vbs
'Funktion: Datum und Uhrzeit dem Bildnamen (z.B. IMG_20170624_143442.jpg) entnehmen und in Exif eintragen
'Copyright Harald Maeckler, Dsseldorf

Option Explicit
Dim n,imagecount,Bild,BildD,Anz,Abbruch,pos,BArray
Dim Bildsammlung,SArray
Dim Datum,jjjj,mm,tt,Zeit,hh,uu,ss,E_Eintrag


'** Start Dialog DateToExif **
FF_AddDialog "DateToExif",136,46
FF_AddControl "DateToExif","Bilder im aktuellen Computerverzeichnis markieren!","STATIC",5,5,126,10
FF_SetControlStyle "DateToExif","Bilder im aktuellen Computerverzeichnis markieren!",1
FF_AddControl "DateToExif","Fortschritt","PROGRESS",5,19,126,4
FF_AddControl "DateToExif","Start","BUTTON",90,30,33,11
FF_AddControl "DateToExif","Abbruch","BUTTON",50,30,33,11
'** End Dialog DateToExif **

do
	Abbruch = false
	Select Case FF_ShowDialog ("DateToExif")
		Case "Start"
			call Eintrag
			if not Abbruch then exit do
		Case "Abbruch","CANCEL"
			exit do
	End Select
loop

FF_CloseDialog ("DateToExif")
'----------------------------------------------------
Sub Eintrag
Dim Fehler : Fehler = false

Bildsammlung = FF_GetSelection(1)
SArray = split(Bildsammlung,vbNewline)
imagecount = ubound(SArray) +1

if imagecount = 0 then
	msgbox "Es ist kein Bild markiert!",vbInformation,"Hinweis"
	exit sub
end if

Anz = 0
For n = 0 to imagecount -1
	Bild = FF_GetImageName(n)
	FF_LoadImage Bild

	pos = InStrRev(Bild,"\")
	BildD = mid(Bild,pos +1)
	if FF_IdentifyImage(Bild) <> 2 then
		msgbox "Das Bild " & BildD & " ist kein JPEG-Bild." & vbNewLine &_
				"Das Bild wird ausgelassen!",vbInformation,"Hinweis"
	else
		on error resume next
		pos = InStrRev(BildD,".")
		BildD = left(BildD,pos -1)
	
		BArray = split(BildD,"_")
		Datum = BArray(1)
		Zeit = BArray(2)
		if err <> 0 then Fehler = true
		on error goto 0
		
		if Fehler or not IsNumeric(Datum) or len(Datum) <> 8 or not IsNumeric(Zeit) or len(Zeit) <> 6 then
			msgbox "Der Bildname " & Bild & " ist nicht konform." & vbNewline &_
					"Das Bild wird ausgelassen!",vbInformation,"Hinweis"
			Fehler = false
		else
			jjjj = left(Datum,4) : mm = mid(Datum,5,2) : tt = right(Datum,2)
			hh = left(Zeit,2) : uu = mid(Zeit,3,2) : ss = right(Zeit,2)
			E_Eintrag = jjjj & ":" & mm & ":" & tt & " " & hh & ":" & uu & ":" & ss
			
			if not FF_HasExif() then FF_CreateExif()
			FF_SetExifTag "DateTimeOriginal",E_Eintrag
			FF_SaveExif Bild
			
			Anz = Anz +1
			FF_SetControl "DateToExif","Fortschritt",imagecount/Anz*100
		end if
	end if
next

msgbox "Von " & imagecount & " wurden " & Anz & " Bilder erfolgreich bearbeitet!",vbInformation,"Hinweis"

End Sub
'----------------------------------------------------
